Index: /palm/trunk/SCRIPTS/subjob
===================================================================
--- /palm/trunk/SCRIPTS/subjob	(revision 1574)
+++ /palm/trunk/SCRIPTS/subjob	(revision 1575)
@@ -23,5 +23,5 @@
 # Current revisions:
 # ------------------
-# 
+# mpp2-queues added to lccrayh
 # 
 # Former revisions:
@@ -417,5 +417,5 @@
                  esac;;
         (lccrayh) case  $ndq  in
-                     (dataq|mpp1q|mpp1testq|smp1q|smp1testq|specialm1q)   error=false;;
+                     (dataq|mpp1q|mpp1testq|mpp2q|mpp2testq|smp1q|smp1testq|specialm1q)   error=false;;
                      (*)                                     error=true;;
                  esac;;
Index: /palm/trunk/SOURCE/Makefile
===================================================================
--- /palm/trunk/SOURCE/Makefile	(revision 1574)
+++ /palm/trunk/SOURCE/Makefile	(revision 1575)
@@ -20,5 +20,5 @@
 # Current revisions:
 # ------------------
-# 
+# +poismg_fast
 # 
 # Former revisions:
@@ -220,5 +220,5 @@
 	init_pegrid.f90 init_pt_anomaly.f90 init_rankine.f90 init_slope.f90 \
 	interaction_droplets_ptq.f90 land_surface_model.f90 local_flush.f90 \
-        local_getenv.f90 local_stop.f90 local_system.f90 local_tremain.f90 \
+   local_getenv.f90 local_stop.f90 local_system.f90 local_tremain.f90 \
 	local_tremain_ini.f90 lpm.f90 lpm_advec.f90 lpm_boundary_conds.f90 \
 	lpm_calc_liquid_water_content.f90 lpm_collision_kernels.f90 \
@@ -231,7 +231,7 @@
 	lpm_write_exchange_statistics.f90 lpm_write_restart_file.f90 \
 	ls_forcing.f90 message.f90 microphysics.f90 modules.f90 mod_kinds.f90 \
-	mod_particle_attributes.f90 netcdf.f90 nudging.f90 \
-	package_parin.f90 palm.f90 parin.f90 plant_canopy_model.f90 poisfft.f90 \
-	poismg.f90 prandtl_fluxes.f90 pres.f90 print_1d.f90 production_e.f90 \
+	mod_particle_attributes.f90 netcdf.f90 nudging.f90 package_parin.f90 \
+	palm.f90 parin.f90 plant_canopy_model.f90 poisfft.f90 poismg.f90 \
+	poismg_fast.f90 prandtl_fluxes.f90 pres.f90 print_1d.f90 production_e.f90 \
 	prognostic_equations.f90 progress_bar.f90 radiation_model.f90 \
 	random_function.f90 random_gauss.f90 random_generator_parallel.f90 \
@@ -249,6 +249,5 @@
 	user_data_output_mask.f90 user_define_netcdf_grid.f90 \
 	user_dvrp_coltab.f90 user_header.f90 user_init.f90 \
-	user_init_3d_model.f90 user_init_grid.f90 \
-        user_init_land_surface.f90 \
+	user_init_3d_model.f90 user_init_grid.f90 user_init_land_surface.f90 \
 	user_init_plant_canopy.f90 user_last_actions.f90 user_lpm_advec.f90 \
 	user_lpm_init.f90 user_lpm_set_attributes.f90 user_module.f90 \
@@ -413,6 +412,7 @@
 poisfft.o: modules.o cpulog.o fft_xy.o mod_kinds.o tridia_solver.o
 poismg.o: modules.o cpulog.o mod_kinds.o
+poismg_fast.o: modules.o cpulog.o mod_kinds.o
 prandtl_fluxes.o: modules.o mod_kinds.o
-pres.o: modules.o cpulog.o mod_kinds.o poisfft.o
+pres.o: modules.o cpulog.o mod_kinds.o poisfft.o poismg_fast.o
 print_1d.o: modules.o cpulog.o mod_kinds.o
 production_e.o: modules.o mod_kinds.o wall_fluxes.o
Index: /palm/trunk/SOURCE/calc_spectra.f90
===================================================================
--- /palm/trunk/SOURCE/calc_spectra.f90	(revision 1574)
+++ /palm/trunk/SOURCE/calc_spectra.f90	(revision 1575)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! adjustments for psolver-queries
 ! 
 ! Former revisions:
@@ -113,5 +113,5 @@
 !
 !-- Reallocate array d in required size
-    IF ( psolver == 'multigrid' )  THEN
+    IF ( psolver(1:9) == 'multigrid' )  THEN
        DEALLOCATE( d )
        ALLOCATE( d(nzb+1:nzt,nys:nyn,nxl:nxr) )
Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 1574)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 1575)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! multigrid_fast added as allowed pressure solver
 ! 
 ! Former revisions:
@@ -716,6 +716,6 @@
 !-- Check whether there are any illegal values
 !-- Pressure solver:
-    IF ( psolver /= 'poisfft'  .AND. &
-         psolver /= 'sor'  .AND.  psolver /= 'multigrid' )  THEN
+    IF ( psolver /= 'poisfft'  .AND.  psolver /= 'sor'  .AND.                  &
+         psolver /= 'multigrid'  .AND.  psolver /= 'multigrid_fast' )  THEN
        message_string = 'unknown solver for perturbation pressure: psolver' // &
                         ' = "' // TRIM( psolver ) // '"'
@@ -723,5 +723,5 @@
     ENDIF
 
-    IF ( psolver == 'multigrid' )  THEN
+    IF ( psolver(1:9) == 'multigrid' )  THEN
        IF ( cycle_mg == 'w' )  THEN
           gamma_mg = 2
@@ -1715,5 +1715,5 @@
 !-- and tools do not work with non-cyclic boundary conditions.
     IF ( bc_lr /= 'cyclic'  .OR.  bc_ns /= 'cyclic' )  THEN
-       IF ( psolver /= 'multigrid' )  THEN
+       IF ( psolver(1:9) /= 'multigrid' )  THEN
           message_string = 'non-cyclic lateral boundaries do not allow ' // &
                            'psolver = "' // TRIM( psolver ) // '"'
Index: /palm/trunk/SOURCE/header.f90
===================================================================
--- /palm/trunk/SOURCE/header.f90	(revision 1574)
+++ /palm/trunk/SOURCE/header.f90	(revision 1575)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! adjustments for psolver-queries, output of seed_follows_topography
 ! 
 ! Former revisions:
@@ -227,4 +227,5 @@
                particles_per_point, pdx, pdy, pdz,  psb, psl, psn, psr, pss,   &
                pst, radius, radius_classes, random_start_position,             &
+               seed_follows_topography,                                        &
                total_number_of_particles, use_particle_tails,                  &
                use_sgs_for_particles, total_number_of_tails,                   &
@@ -424,6 +425,6 @@
     ELSEIF ( psolver == 'sor' )  THEN
        WRITE ( io, 112 )  nsor_ini, nsor, omega_sor
-    ELSEIF ( psolver == 'multigrid' )  THEN
-       WRITE ( io, 135 )  cycle_mg, maximum_grid_level, ngsrb
+    ELSEIF ( psolver(1:9) == 'multigrid' )  THEN
+       WRITE ( io, 135 )  TRIM(psolver), cycle_mg, maximum_grid_level, ngsrb
        IF ( mg_cycles == -1 )  THEN
           WRITE ( io, 140 )  residual_limit
@@ -1788,4 +1789,5 @@
        IF ( use_sgs_for_particles )  WRITE ( io, 488 )  dt_min_part
        IF ( random_start_position )  WRITE ( io, 481 )
+       IF ( seed_follows_topography )  WRITE ( io, 496 )
        IF ( particles_per_point > 1 )  WRITE ( io, 489 )  particles_per_point
        WRITE ( io, 495 )  total_number_of_particles
@@ -1907,5 +1909,5 @@
 133 FORMAT ('     Precipitation parameterization via Kessler-Scheme')
 134 FORMAT (' --> Additional prognostic equation for a passive scalar')
-135 FORMAT (' --> Solve perturbation pressure via multigrid method (', &
+135 FORMAT (' --> Solve perturbation pressure via ',A,' method (', &
                   A,'-cycle)'/ &
             '     number of grid levels:                   ',I2/ &
@@ -2326,4 +2328,6 @@
                     F8.2,' s'/)
 495 FORMAT ('       Number of particles in total domain: ',I10/)
+496 FORMAT ('       Initial vertical particle positions are interpreted ', &
+                    'as relative to the given topography')
 500 FORMAT (//' 1D-Model parameters:'/                           &
               ' -------------------'//                           &
Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 1574)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 1575)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! adjustments for psolver-queries
 ! 
 ! Former revisions:
@@ -356,5 +356,5 @@
     IF ( psolver == 'sor' )  THEN
        ALLOCATE( p_loc(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-    ELSEIF ( psolver == 'multigrid' )  THEN
+    ELSEIF ( psolver(1:9) == 'multigrid' )  THEN
 !
 !--    For performance reasons, multigrid is using one ghost layer only
@@ -1135,5 +1135,5 @@
 !
 !--    In case of iterative solvers, p must get an initial value
-       IF ( psolver == 'multigrid'  .OR.  psolver == 'sor' )  p = 0.0_wp
+       IF ( psolver(1:9) == 'multigrid'  .OR.  psolver == 'sor' )  p = 0.0_wp
 
 !
Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 1574)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 1575)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! adjustments for psolver-queries
 ! 
 ! Former revisions:
@@ -332,5 +332,5 @@
 !-- containing with appropriate grid information is created for these
 !-- solvers.
-    IF ( psolver /= 'multigrid' )  THEN
+    IF ( psolver(1:9) /= 'multigrid' )  THEN
        ALLOCATE( ddzu_pres(1:nzt+1) )
        ddzu_pres = ddzu
@@ -341,5 +341,5 @@
 !-- In case of multigrid method, compute grid lengths and grid factors for the
 !-- grid levels
-    IF ( psolver == 'multigrid' )  THEN
+    IF ( psolver(1:9) == 'multigrid' )  THEN
 
        ALLOCATE( ddx2_mg(maximum_grid_level), ddy2_mg(maximum_grid_level), &
@@ -1047,5 +1047,5 @@
 !
 !-- Calculate wall flag arrays for the multigrid method
-    IF ( psolver == 'multigrid' )  THEN
+    IF ( psolver(1:9) == 'multigrid' )  THEN
 !
 !--    Gridpoint increment of the current level
Index: /palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- /palm/trunk/SOURCE/init_pegrid.f90	(revision 1574)
+++ /palm/trunk/SOURCE/init_pegrid.f90	(revision 1575)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! adjustments for psolver-queries, calculation of ngp_xz added
 ! 
 ! Former revisions:
@@ -761,5 +761,5 @@
 !-- Calculate number of grid levels necessary for the multigrid poisson solver
 !-- as well as the gridpoint indices on each level
-    IF ( psolver == 'multigrid' )  THEN
+    IF ( psolver(1:9) == 'multigrid' )  THEN
 
 !
@@ -977,6 +977,6 @@
 !-- Do these calculations for the model grid and (if necessary) also
 !-- for the coarser grid levels used in the multigrid method
-    ALLOCATE ( ngp_yz(0:maximum_grid_level), type_xz(0:maximum_grid_level),&
-               type_yz(0:maximum_grid_level) )
+    ALLOCATE ( ngp_xz(0:maximum_grid_level), ngp_yz(0:maximum_grid_level),     &
+               type_xz(0:maximum_grid_level), type_yz(0:maximum_grid_level) )
 
     nxl_l = nxl; nxr_l = nxr; nys_l = nys; nyn_l = nyn; nzb_l = nzb; nzt_l = nzt
@@ -1007,9 +1007,10 @@
 !
 !-- Definition of MPI-datatypes for multigrid method (coarser level grids)
-    IF ( psolver == 'multigrid' )  THEN
+    IF ( psolver(1:9) == 'multigrid' )  THEN
 !    
 !--    Definition of MPI-datatyoe as above, but only 1 ghost level is used
        DO  i = maximum_grid_level, 1 , -1
 
+          ngp_xz(i) = (nzt_l - nzb_l + 2) * (nxr_l - nxl_l + 3)
           ngp_yz(i) = (nzt_l - nzb_l + 2) * (nyn_l - nys_l + 3)
 
@@ -1129,5 +1130,5 @@
 !
 !-- Allocate wall flag arrays used in the multigrid solver
-    IF ( psolver == 'multigrid' )  THEN
+    IF ( psolver(1:9) == 'multigrid' )  THEN
 
        DO  i = maximum_grid_level, 1, -1
Index: /palm/trunk/SOURCE/lpm_init.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_init.f90	(revision 1574)
+++ /palm/trunk/SOURCE/lpm_init.f90	(revision 1575)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! initial vertical particle position is allowed to follow the topography
 ! 
 ! Former revisions:
@@ -101,5 +101,6 @@
 
     USE indices,                                                               &
-        ONLY:  nx, nxl, nxlg, nxrg, nxr, ny, nyn, nys, nyng, nysg, nz, nzb, nzt
+        ONLY:  nx, nxl, nxlg, nxrg, nxr, ny, nyn, nys, nyng, nysg, nz, nzb,    &
+               nzb_w_inner, nzt
 
     USE kinds
@@ -126,5 +127,5 @@
                 prt_count, psb, psl, psn, psr, pss, pst,                       &
                 radius, random_start_position, read_particles_from_restartfile,&
-                skip_particles_for_tail, sort_count,                           &
+                seed_follows_topography, skip_particles_for_tail, sort_count,  &
                 tail_mask, total_number_of_particles, total_number_of_tails,   &
                 use_particle_tails, use_sgs_for_particles,                     &
@@ -649,5 +650,5 @@
                    pos_x = psl(i)
 
-                   DO WHILE ( pos_x <= psr(i) )
+            xloop: DO WHILE ( pos_x <= psr(i) )
 
                       IF ( pos_x >= ( nxl - 0.5_wp ) * dx  .AND.  &
@@ -738,7 +739,20 @@
                                tmp_particle%tail_id    = 0
                             ENDIF
+!
+!--                         Determine the grid indices of the particle position
                             ip = ( tmp_particle%x + 0.5_wp * dx ) * ddx
                             jp = ( tmp_particle%y + 0.5_wp * dy ) * ddy
                             kp = tmp_particle%z / dz + 1 + offset_ocean_nzt_m1
+
+                            IF ( seed_follows_topography )  THEN
+!
+!--                            Particle height is given relative to topography
+                               kp = kp + nzb_w_inner(jp,ip)
+                               tmp_particle%z = tmp_particle%z + zw(kp)
+                               IF ( kp > nzt )  THEN
+                                  pos_x = pos_x + pdx(i)
+                                  CYCLE xloop
+                               ENDIF
+                            ENDIF
 
                             local_count(kp,jp,ip) = local_count(kp,jp,ip) + 1
@@ -758,5 +772,5 @@
                       pos_x = pos_x + pdx(i)
 
-                   ENDDO
+                   ENDDO xloop
 
                 ENDIF
Index: /palm/trunk/SOURCE/mod_particle_attributes.f90
===================================================================
--- /palm/trunk/SOURCE/mod_particle_attributes.f90	(revision 1574)
+++ /palm/trunk/SOURCE/mod_particle_attributes.f90	(revision 1575)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! +seed_follows_topography
 ! 
 ! Former revisions:
@@ -69,4 +69,5 @@
                 particle_advection = .FALSE., random_start_position = .FALSE., &
                 read_particles_from_restartfile = .TRUE.,                      &
+                seed_follows_topography = .FALSE.,                             &
                 uniform_particles = .TRUE., use_kernel_tables = .FALSE.,       &
                 use_particle_tails = .FALSE., use_sgs_for_particles = .FALSE., &
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 1574)
+++ /palm/trunk/SOURCE/modules.f90	(revision 1575)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! +ngp_xz
 ! 
 ! Former revisions:
@@ -1304,5 +1304,5 @@
 
 
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ngp_yz, type_xz, type_yz
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ngp_xz, ngp_yz, type_xz, type_yz
 
     LOGICAL ::  left_border_pe  = .FALSE., north_border_pe = .FALSE., &
Index: /palm/trunk/SOURCE/package_parin.f90
===================================================================
--- /palm/trunk/SOURCE/package_parin.f90	(revision 1574)
+++ /palm/trunk/SOURCE/package_parin.f90	(revision 1575)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! +seed_follows_topography in particles_par
 ! 
 ! Former revisions:
@@ -129,7 +129,7 @@
                psb, psl, psn, psr, pss, pst, radius, radius_classes,           &
                random_start_position, read_particles_from_restartfile,         &
-               skip_particles_for_tail, use_particle_tails,                    &
-               use_sgs_for_particles, vertical_particle_advection,             &
-               write_particle_statistics
+               seed_follows_topography, skip_particles_for_tail,               &
+               use_particle_tails, use_sgs_for_particles,                      &
+               vertical_particle_advection, write_particle_statistics
 
     USE plant_canopy_model_mod,                                                &
@@ -212,4 +212,5 @@
                                   radius_classes, random_start_position,       &
                                   read_particles_from_restartfile,             &
+                                  seed_follows_topography,                     &
                                   skip_particles_for_tail,                     &
                                   use_particle_tails, use_sgs_for_particles,   &
Index: /palm/trunk/SOURCE/pres.f90
===================================================================
--- /palm/trunk/SOURCE/pres.f90	(revision 1574)
+++ /palm/trunk/SOURCE/pres.f90	(revision 1575)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! poismg_fast + respective module added, adjustments for psolver-queries
 ! 
 ! Former revisions:
@@ -114,4 +114,6 @@
         ONLY:  poisfft
 
+    USE poismg_mod
+
     USE statistics,                                                            &
         ONLY:  statistic_regions, sums_divnew_l, sums_divold_l, weight_pres,   &
@@ -144,5 +146,5 @@
 !-- Multigrid method expects array d to have one ghost layer.
 !-- 
-    IF ( psolver == 'multigrid' )  THEN
+    IF ( psolver(1:9) == 'multigrid' )  THEN
      
        DEALLOCATE( d )
@@ -293,5 +295,5 @@
     CALL cpu_log( log_point_s(1), 'divergence', 'start' )
 
-    IF ( psolver == 'multigrid' )  THEN
+    IF ( psolver(1:9) == 'multigrid' )  THEN
        !$OMP PARALLEL DO SCHEDULE( STATIC )
        DO  i = nxl-1, nxr+1
@@ -388,13 +390,9 @@
 !
 !-- Compute the pressure perturbation solving the Poisson equation
-    IF ( psolver(1:7) == 'poisfft' )  THEN
+    IF ( psolver == 'poisfft' )  THEN
 
 !
 !--    Solve Poisson equation via FFT and solution of tridiagonal matrices
-       IF ( psolver == 'poisfft' )  THEN
-
-          CALL poisfft( d )
-
-       ENDIF
+       CALL poisfft( d )
 
 !
@@ -492,5 +490,5 @@
        tend = p_loc
 
-    ELSEIF ( psolver == 'multigrid' )  THEN
+    ELSEIF ( psolver(1:9) == 'multigrid' )  THEN
 
 !
@@ -511,5 +509,9 @@
        ENDIF
 
-       CALL poismg( tend )
+       IF ( psolver == 'multigrid' )  THEN
+          CALL poismg( tend )
+       ELSE
+          CALL poismg_fast( tend )
+       ENDIF
 
        IF ( gathered_size > subdomain_size )  THEN
